"use strict";

exports.__esModule = true;
exports.TaggedTemplateExpression = TaggedTemplateExpression;
exports.TemplateElement = TemplateElement;
exports.TemplateLiteral = TemplateLiteral;

function TaggedTemplateExpression(node) {
  this.print(node, "tag");
  this.print(node, "quasi");
}

function TemplateElement(node) {
  this._push(node.value.raw);
}

function TemplateLiteral(node) {
  this.push("`");

  var quasis = node.quasis;

  for (var i = 0; i < quasis.length; i++) {
    this.print(quasis[i], node);

    if (i + 1 < quasis.length) {
      this.push("${");
      this.print(node.expressions[i], node);
      this.push("}");
    }
  }

  this._push("`");
}
//# sourceMappingURL=../../../packages/tacoscript-generator/lib/generators/template-literals.js.map
